// (C) Copyright 1992 Jim Patterson
#import <appkit/View.h>

#define TA_LINE_HEIGHT 20
#define TA_SIDE_MARGIN 20
#define TA_NUM_CLIPVIEW_LINES 25
#define TA_NUM_GAMEVIEW_LINES 100

#define TA_CLIPVIEW_X 13
#define TA_CLIPVIEW_Y 139
#define TA_CLIPVIEW_W 400
#define TA_CLIPVIEW_H (TA_LINE_HEIGHT * TA_NUM_CLIPVIEW_LINES)

#define TA_GAMEVIEW_FADEPART_H (2*TA_CLIPVIEW_H)
#define TA_GAMEVIEW_TRAILER_H  (2 * TA_GAMEVIEW_FADEPART_H)
#define TA_GAMEVIEW_HEADER_H  (TA_CLIPVIEW_H/2)
#define TA_GAMEVIEW_TEXTPART_H  (TA_LINE_HEIGHT * TA_NUM_GAMEVIEW_LINES)
#define TA_GAMEVIEW_TRAILER_BOX_W  200
#define TA_GAMEVIEW_TRAILER_BOX_H 100
#define TA_GAMEVIEW_TRAILER_XMARGIN ((TA_CLIPVIEW_W - TA_GAMEVIEW_TRAILER_BOX_W)/2)
#define TA_GAMEVIEW_TRAILER_YMARGIN ((3 * TA_CLIPVIEW_H - TA_GAMEVIEW_TRAILER_BOX_H)/2) 

#define TA_GAMEVIEW_X 0
#define TA_GAMEVIEW_Y 0
#define TA_GAMEVIEW_W TA_CLIPVIEW_W
#define TA_GAMEVIEW_H (TA_GAMEVIEW_TEXTPART_H + TA_GAMEVIEW_HEADER_H +TA_GAMEVIEW_TRAILER_H)

#define TA_GAMEVIEW_STOP_H TA_GAMEVIEW_H
#define TA_GAMEVIEW_SPEEDUP_H  (TA_GAMEVIEW_HEADER_H+TA_GAMEVIEW_TEXTPART_H + TA_CLIPVIEW_H)
#define TA_GAMEVIEW_TOBLACK_H ((TA_GAMEVIEW_HEADER_H/2) + ((TA_GAMEVIEW_HEADER_H/2)%2))

#define TA_MAX_LETTER_WIDTH 30

@interface GameView:View
{
	char gameLetters[TA_NUM_GAMEVIEW_LINES];
	float gameLetterXLocs[TA_NUM_GAMEVIEW_LINES];
	int lowestNonemptyRow;
	id cacheWindow;
	id gameFont;
	NXRect clearingRect;
}


+ standardNewFrame;
- drawSelf:(NXRect *) tR: (int) count;
- free;
- fillWithLetters;							// fill view with lots of letters
- lowestLetterWasHit:(int) gProgress;						// kill lowest letter, return next lowest
- (char) lowestLetter;						// bottommost letter on the screen
- (int) lowestNonemptyRow;



@end

