// (C) Copyright 1992 Jim Patterson


#import <objc/Object.h>


#define TA_MAX_STAT_CHARS  (100*128)

typedef struct keyStat {
	char key;
	int numMissed,numInGame;
	float relFreq,absFreq;
	char relFreqBuff[20],absFreqBuff[20];
} keyStatType;
 

@interface PerformanceEvaluator:Object
{
	id keyColumn;
	id relColumn;
	id absColumn;
	id suggText;
	keyStatType *keyInfo[128];
	keyStatType *largest[6];		// pointers to 6 most common mistakes
	int missedCount;
	int gameCompleted;
	char textBuff[TA_MAX_STAT_CHARS];
	id performanceEvaluatorWindow;
}

+new;
- setKeyColumn:anObject;
- setRelColumn:anObject;
- setAbsColumn:anObject;
- setSuggText:anObject;
- setPerformanceEvaluatorWindow:anObject;
- tellGameCompleted:(BOOL) wasCompleted;
- reset;
- flush;
- logKeyMiss :(char) aChar;
- logOccurrence :(char) aChar;
- sortKeyInfo;
- summarize;
- debugDump;
- writeInfo:(NXTypedStream *) tstream;
- readInfo:(NXTypedStream *) tstream;

- free;

@end
